<?php

/*
 * 
 * 
 */

/* University of Illinois/NCSA Open Source License for whosaffected.php.

Copyright (c) 2009/12 Jim Champ/Surrey County Council
All rights reserved.
Developed by: 		Jim Champ
www.devboats.co.uk/lscriptlist
Permission is hereby granted, free of charge, to any person obtaining a
copy of this software and associated documentation files (the
"Software"), to deal with the Software without restriction, including
without limitation the rights to use, copy, modify, merge, publish,
distribute, sublicense, and/or sell copies of the Software, and to
permit persons to whom the Software is furnished to do so, subject to
the following conditions:

Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimers.

Redistributions in binary form must reproduce the above
copyright notice, this list of conditions and the following disclaimers
in the documentation and/or other materials provided with the
distribution.

Neither the names of Surrey County Council nor the names of its contributors may be used to endorse
or promote products derived from this Software without specific prior
written permission.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
IN NO EVENT SHALL THE CONTRIBUTORS OR COPYRIGHT HOLDERS BE LIABLE FOR
ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
SOFTWARE OR THE USE OR OTHER DEALINGS WITH THE SOFTWARE.*/

// This next function is for versions of PHP below 5.1 which don't include the fputcsv function
// If you wll never use versions of PHP below 5.1 you can delete it

// **** Start fputcsv code ****

if (!function_exists('fputcsv')) {
     function fputcsv(&$handle, $fields = array(), $delimiter = ',', $enclosure = '"') {
          // this function is example code from php documentation site
          // contributed by jon+dontspamme at phpsitesolutions dot com
          //  30-Jul-2008 05:44
          //it is licensed under the followimg creative commons license
          //  http://uk.php.net/manual/en/cc.license.php
          // the rest of the code is licensed under University of illinois/NCSA.
          
          // Sanity Check
          if (!is_resource($handle)) {
               trigger_error('fputcsv() expects parameter 1 to be resource, ' .
               gettype($handle) . ' given', E_USER_WARNING);
               return false;
          }
          
          if ($delimiter!=NULL) {
               if( strlen($delimiter) < 1 ) {
                    trigger_error('delimiter must be a character', E_USER_WARNING);
                    return false;
               }elseif( strlen($delimiter) > 1 ) {
                    trigger_error('delimiter must be a single character', E_USER_NOTICE);
               }
               
               /* use first character from string */
               $delimiter = $delimiter[0];
          }
          
          if( $enclosure!=NULL ) {
               if( strlen($enclosure) < 1 ) {
	               trigger_error('enclosure must be a character', E_USER_WARNING);
    	           return false;
               }elseif( strlen($enclosure) > 1 ) {
        	       trigger_error('enclosure must be a single character', E_USER_NOTICE);
               }
               
               /* use first character from string */
               $enclosure = $enclosure[0];
          }
          
          $i = 0;
          $csvline = '';
          $escape_char = '\\';
          $field_cnt = count($fields);
          $enc_is_quote = in_array($enclosure, array('"',"'"));
          reset($fields);
          
          foreach( $fields AS $field ) {
               
               /* enclose a field that contains a delimiter, an enclosure character, or a newline */
               if( is_string($field) && (
               strpos($field, $delimiter)!==false ||
               strpos($field, $enclosure)!==false ||
               strpos($field, $escape_char)!==false ||
               strpos($field, "\n")!==false ||
               strpos($field, "\r")!==false ||
               strpos($field, "\t")!==false ||
               strpos($field, ' ')!==false ) ) {
                    
                    $field_len = strlen($field);
                    $escaped = 0;
                    
                    $csvline .= $enclosure;
               		for( $ch = 0; $ch < $field_len; $ch++ )    {
               			if( $field[$ch] == $escape_char && $field[$ch+1] == $enclosure && $enc_is_quote ) {
               				continue;
               			}elseif( $field[$ch] == $escape_char ) {
               				$escaped = 1;
               			}elseif( !$escaped && $field[$ch] == $enclosure ) {
               				$csvline .= $enclosure;
               			}else{
               				$escaped = 0;
            	   		}
        	    	   $csvline .= $field[$ch];
    	           }
	               $csvline .= $enclosure;
               } else {
    	           $csvline .= $field;
               }
               
               if( $i++ != $field_cnt ) {
	               $csvline .= $delimiter;
               }
          }
          
          $csvline .= "\n";
          
          return fwrite($handle, $csvline);
     }
}

// **** End of fputcsv code ****


// the program produces an array which then needs to be sent as a download.
// that means that when that module is called the download headers need to
// be the first thing sent to the browser, so must be the result of a
// post command. passing a huge array across in a post command was ugly
// and probably has security implications, so instead we use this temp
// file. The whole utility is maybe more vulnerable to misbehavious than some
// but in any case I can't imagine wanting to ezpose the directory publicly
// anyway. I don't advise exposing this code outside your firewall

// **** OES/Netware change required ****

// For OES you need a path to tmp for the download file
// There will be lots of potential security gotchas in OES, depending on what level of security you
// have set in the browser and with php. in Netware 6.5 you don't need to bother: it will default to sys:php5.
// If you do want a path in Netware of course you will need to use Netware syntax for the path: sys:/tmp or whatever

//$fptempfile = "/tmp/~tmpwhof.txt";  // This line for OES
$fptempfile = "~tmpwhof.txt";         // This line for Netware

if (@$_POST['fdownload'] > "" ) {
     downloadData();
     @unlink($fptempfile);
     exit;
} else {
     if (@$HTTP_POST_VARS['fdownload'] > "" ) {
          downloadData();
          @unlink($fptempfile);
          exit;
     }
}

// having got past the download we can display an html header
// the pageheader function contains all the basic HTML, so
// you can change look and feel there...
pageHeader();

//Second codebranch - if there's text in fdisplay (any text!)
// we assume that we've been through the authentication form and want to query the directory
if (@$_POST['fdisplay'] > "" ) {
     // so the displaydata function generates output to screen and preps the doanload file
     displayData();
     exit;
} else {
     if (@$HTTP_POST_VARS['fdisplay'] > "" ) {
          displayData();
          exit;
     }
}

//finally, i we aren't doing anything else, we drop through to here and display the initial
//form to collect authentication data and other parameters
//its easier to construct the HTML form with this syntax rather than use unmpteen echos and things.

$b = <<<HTMLFORM

<!-- Content -->
<form method="POST" action="whosAffected.php"
	enctype="x-www-form-urlencoded">

	
	
	<table summary="User Entry Form">
	<tr>
		<td>LDAP Admin User ID:</td>
		<td><input type="text" name="ldap_id" size="40" maxlength="60" /></td>
	</tr>
	<tr>
		<td>Admin User LDAP Context:</td>
		<td><input type="text" name="ldap_cx" size="40" maxlength="60"
			value="ou=at,ou=your,o=company" /></td>
	</tr>
	<tr>
		<td>LDAP Password:</td>
		<td><input type="password" name="ldap_pw" size="40"
			maxlength="60" /></td>
	</tr>
	<tr>
		<td>LDAP Server:</td>
		<td><input type="text" name="ldap_server" size="40"
			maxlength="60" value="[your LDAP Server]" /></td>
	</tr>
	
	<!--  I take the view that asking for LDAP root is not appropriate for this utility because
		I want the users to search the whole tree even if it takes time to find anything that
		might catch them out. Your mileage may vary, so here's the form entry 
     	<tr>
     		<td>Search Context:</td>
     		<td><input type="text" name="ldap_root" size="40"
     			maxlength="60" value="o=company" /></td>
     	</tr>
	-->
	<tr>
		<td colspan="2">
		<hr />
		</td>
	</tr>
	<tr>
		<td>Server Name:</td>
		<td><input type="text" name="name_of_svr" size="40" maxlength="60"
			value="" />
			</td>
		</tr>

	<tr>
		<td><input type="submit" value="Post Details" />
		<INPUT TYPE="hidden" NAME="fdisplay" VALUE="GoGoGo" >
		</td>
		<td><input type="reset" value="Clear Form" /></td>
	</tr>
</table>
<h2>User Notes</h2>
<p>The User ID should be your normal LAN user id. The User LDAP
context should have a default set by your admin. If your user id is
in a different context then alter it approriately, bearing in mind the
need to use LDAP syntax with a comma rather than a stop as the
delimiter.The LDAP Password will be the normal password for the user id.
The LDAP server can be changed if desired, but its probably best to use
the default server or another of the DS master servers in the tree. </p>


HTMLFORM;

echo $b;

//finally a function to ends the html, you may wish to customise this as well
closedocument();
//and the final curtain...
exit;


Function displayData(){
     //There's an issue here if you have older implementations of PHP which use http_post_vars rather than _post.
     //I haven't bothered to put in the extra code since there are none such left at my site and there must be few by now
     //use the code higher up as a model if required.
     
     //there probably ought to be some checking/validation of the data so that there's a pretence at entering reasonable fields
     // if you wish to expose this code outside your network - and personally I would not without a very thorough code audit
     // then there definitely needs to be validation. Its all a bit too open for a public system I think.
     $ldap_id=$_POST['ldap_id'];
     $ldap_cx=$_POST['ldap_cx'];
     $ldap_pw=$_POST['ldap_pw'];
     $ldap_server=$_POST['ldap_server'];
     //you could put a start DN if you want, but I wanted the whole tree with no choices
     $ldap_root=""; //   $_POST['ldap_root'];
     $name_of_svr=$_POST['name_of_svr'];
     //$ldap_sr="objectClass=" . $_POST['ldap_sr'];
     
     $ldap_id="cn=" . $ldap_id . "," . $ldap_cx;
     
     $ldap_sr="objectClass=organizationalUnit" ;
     //these are other object classes. If your oganisation makes heavy use of login scripts in say profile objects 
     //or has users direct in Organisation objects then you will need to process these other object classes...
     //Organization
     //groupOfNames
     //Template
     
     //echo "Line Nums: *$line_nums_enabled*<br>";
     //echo "Search string: *$ldap_sr*<br>";
     //echo "User id: *$ldap_id*<br>";
     
     echo "<h2>with server $name_of_svr?</h2>";
     
     // *****************************************************
     // **     Organizational Unit Module Starts here      **
     // *****************************************************
     
     echo "<h3>Organizational Unit Drive Mappings</h3>\r\n";
     
     // So we start by connecting to LDAP
     
     echo "<p>Connecting to LDAP server...  ";
     
     $ds=ldap_connect("$ldap_server");  // must be a valid LDAP server!
     
     // echo "\n<p>Connection results".$ds."</p>";
     
     
     if(@ldap_bind($ds, $ldap_id,$ldap_pw)) {
	     echo " ...succeeded</br>\n";
    	 // we have now made an LDAP connection
     
     } else {
          echo " failed.</p>\n<h2>LDAP Authentication Failed</h2>\n";
          echo "<p>User id and/or Password credentials were incorrect</p>\n";
          echo "<p>User id and context entered was " . $ldap_id . "</p>\n";
          echo "<p>Use back to go back to the form and renter the LDAP user id and password. Make sure that you used ";
          echo "correct LDAP syntax (ou=unit,o=org) rather than NDS syntax for the user context.</p>\n";
          exit;
     }
     
     //$ldap_sr = "sn=*" ;
     //echo "Searching in " . $ldap_root , " for " . $ldap_sr . " ...<br>\n";
     // Search surname entry
     
     $ldap_attrs=array("cn","loginScript");
     $sr=ldap_search($ds, $ldap_root, $ldap_sr, $ldap_attrs);
     
     //echo "\nSearch result is " . $sr . "<br>\n";
     
     $entry = @ldap_first_entry($ds, $sr);
     if(@ldap_count_entries($ds, $sr) == 1 ) {
		//echo  "1 directory entry returned.</p>\n";
     
     } else {
		//echo  @ldap_count_entries($ds, $sr) . " directory entries returned.</p>\n";
     }
     
     // a download button...
     echo "<p><FORM METHOD=\"POST\" ACTION=\"whosAffected.php\" ENCTYPE=\"x-www-form-urlencoded\">";
     echo "<INPUT TYPE=\"hidden\" NAME=\"fdownload\" VALUE=\"GoGoGo\" >";
     echo "<INPUT TYPE=\"submit\" VALUE=\"Download Output\"></TD>";
     echo "</FORM></p>";
     
     //this variable for text download
     $lsdata = "DN,Script\r\n";
     //and start the screen header
     echo "<table>";
     echo "   <tr><th>Org Unit</th>\n";
     echo "   <th>Drive Mappings</th><th>Users in OU</th></tr>\n";
     
     // a variable to count the OUs...
     $ou_count = 0;
     $mapped_user_count = 0; 	
     
     //$ou_array[]="";
     while ($entry) {
          $attrs = @ldap_get_attributes($ds,$entry);
          
          $udn = @ldap_get_dn($ds,$entry);
          $pres_dn = $udn;
          $udn =  str_ireplace("cn=",".",$udn) ;
          $udn =  str_ireplace(",ou=",".",$udn) ;
          $udn =  str_ireplace(",o=",".",$udn) ;
          $tdn = $udn . ",";
          
          //if the sting we are searching on exists in the login script we do stuff
          if(stripos(@$attrs["loginScript"][0],$name_of_svr)!== FALSE) {
               
               // We are doing some silly stuff here with an array for the output
               //this is so that we first do an LDAP search for all the relevant OUs and grab the login scripts
               //and then serach each OH for a list of users
               $fudn =  "<tr><td>$udn</td><td>" ;
               
               //explode the login script using the new line chars
               $arr_lsc = explode("\n", $attrs["loginScript"][0] );
               foreach($arr_lsc as $lsc_line) {
                    //iterate through the login script
                    if(stripos($lsc_line,$name_of_svr)!== FALSE) {
                         // and just display individual lines with the server in
                         $fudn .=   " $lsc_line <br>";
                         $lsdata .= $tdn . $lsc_line;
                    }
               }
               $fudn .=  "</td>";
               $ou_array[$pres_dn] = $fudn;
               $ou_count++;
          }
          
          $entry = ldap_next_entry($ds, $entry);
          
     }
     // so at this point $ou_array contains the html code for each row of the table, with no trailing hr
     // we need to search for users in each OU, and then grab that data and append it to the table...
     
     foreach($ou_array as $ou => $ou_code) {
          // SO $OU contains the ou, and we want to do an ldap search with this as the base
          // whereas $ou_code contains the html code we are playing with
          $ldap_sr="sn=*" ;
          $ldap_attrs=array("cn", "givenName", "sn");
          $ldap_root = $ou;
          $sr=ldap_search($ds, $ldap_root, $ldap_sr, $ldap_attrs);
          
          $entry = @ldap_first_entry($ds, $sr);
          //echo "debug *$ou* *" . substr($ou_code,3,25) . "*<br>";
          echo $ou_code;
          echo "<td>";
          while ($entry) {
               $attrs = @ldap_get_attributes($ds,$entry);
     	       $mapped_user_count ++;
               
               echo  @$attrs["cn"][0] ;
               echo " (" . @$attrs["givenName"][0] . " " .  @$attrs["sn"][0] . ")<br>";
               $entry = ldap_next_entry($ds, $entry);
          }
          echo "</td><tr>";
     }
     echo "</table></p>\n";
     echo "<p>Total $mapped_user_count users with drive mappings on this server.</p>";
     
     
     // *****************************************************
     // **     User Home Directory Module Starts here      **
     // *****************************************************
     
     
     echo "<h3>User Home Directories</h3>\r\n";
     $lsdata .= "\r\rDN,HomeDir,Name\r\n";
     
     $ldap_sr="sn=*" ;
     $hdir_user_count = 0;
     
     
     $ldap_attrs=array("cn","loginScript", "ndsHomeDirectory", "givenName", "sn", "loginTime");
     $sr=ldap_search($ds, $ldap_root, $ldap_sr, $ldap_attrs);
     
     //echo "\nSearch result is " . $sr . "<br /\n>";
     
     $entry = @ldap_first_entry($ds, $sr);
     if(@ldap_count_entries($ds, $sr) == 1 ) {
	     //    echo  "1 directory entry returned.</p>\n";
     
     } else {
    	 //    echo  @ldap_count_entries($ds, $sr) . " directory entries returned.</p>\n";
     }
     
     echo "<table>";
     echo "   <tr><th>DN (inc context)</th>\n";
     echo "   <th>Home Directory</th>\n";
     echo "   <th>Name</th></tr>\n";
     
     
     while ($entry) {
          $attrs = @ldap_get_attributes($ds,$entry);
          
          $udn = @ldap_get_dn($ds,$entry);
          //$udn =  str_ireplace("cn=",".",$udn) ;
          $udn =  str_ireplace(",ou=",".",$udn) ;
          $udn =  str_ireplace(",o=",".",$udn) ;
          
          $hdir =  str_ireplace("cn=","",@$attrs["ndsHomeDirectory"][0]) ;
          $hdir = @substr($hdir,0,strpos($hdir,","));
          $hdir =  trim( str_ireplace("_","\\",$hdir) );
          $hdir = $hdir .  trim(substr(@$attrs["ndsHomeDirectory"][0], strrpos($attrs["ndsHomeDirectory"][0], "#")));
          $hdir =  str_ireplace("/","\\",$hdir) ;
          $hdir =  str_ireplace("#","\\",$hdir) ;
          $hdir =  str_ireplace("\\\\","\\",$hdir) ;
          $hdir = "\\\\" . $hdir;
          
          if(stripos($hdir,$name_of_svr)!== FALSE) {
               $hdir_user_count ++;
               echo "<tr><td>" . $udn . "</td>";
               echo "<td>" . $hdir . "</td>\n";
               $fname =  @$attrs["cn"][0] . " (" . @$attrs["givenName"][0] . " " .  @$attrs["sn"][0] . ")";
               echo "<td>$fname</td></tr>";
               $lsdata .= "$udn,$hdir,$fname\r";
          }
          $entry = ldap_next_entry($ds, $entry);
     }
     
     echo "</table>\n";
     echo "<p>Total $hdir_user_count users with home directories on this server.</p>\n";
	 echo "<p>Note: Often many of the same users will appear under both categories. A better estimate of total users affected might be whichever is the larger number rather than the two added together.</p>\n";
     
     ldap_close($ds);
     
     echo "<p><FORM METHOD=\"POST\" ACTION=\"whosAffected.php\" ENCTYPE=\"x-www-form-urlencoded\">";
     echo "<INPUT TYPE=\"hidden\" NAME=\"fdownload\" VALUE=\"GoGoGo\" >";
     echo "<INPUT TYPE=\"submit\" VALUE=\"Download Output\"></TD>";
     echo "</FORM></p>";
     
     global $fptempfile;
     
     @unlink($fptempfile);
     $fhandle = fopen($fptempfile, "wb");
     
     fwrite($fhandle,$lsdata);
     
     $r=fclose($fhandle);
     
     closedocument();
     
     exit;
}

Function downloadData(){
     header("Content-Disposition: filename=\"whosAffected.csv\"");
     header("Content-Type: application/force-download");
     header("Content-Type: application/octet-stream");
     header("Content-Type: application/download");
     header("Content-Description: File Transfer");
     //these two added to try and stop cahing rf PHP docs...
     header("Cache-Control: no-cache");
     header("Expires: -1");
     global $fptempfile;
     #flush(); // this doesn't really matter.
     readfile($fptempfile);

}

function closedocument(){
     //any page foooter or the like goes here...
     echo "</body>\n</html>\n";
}

function pageHeader(){
	$h= <<<HTMLHEADER
<html>
<head>

<!--
 University of Illinois/NCSA Open Source License for whosaffected.php.

 Copyright (c) 2009/11 Jim Champ/Surrey County Council
 All rights reserved.
 Developed by: 		Jim Champ
 www.devboats.co.uk/lscriptlist
 Permission is hereby granted, free of charge, to any person obtaining a
 copy of this software and associated documentation files (the
 "Software"), to deal with the Software without restriction, including
 without limitation the rights to use, copy, modify, merge, publish,
 distribute, sublicense, and/or sell copies of the Software, and to
 permit persons to whom the Software is furnished to do so, subject to
 the following conditions:

 Redistributions of source code must retain the above copyright
 notice, this list of conditions and the following disclaimers.

 Redistributions in binary form must reproduce the above
 copyright notice, this list of conditions and the following disclaimers
 in the documentation and/or other materials provided with the
 distribution.

 Neither the names of Surrey County Council nor the names of its contributors may be used to endorse
 or promote products derived from this Software without specific prior
 written permission.
 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
 OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 IN NO EVENT SHALL THE CONTRIBUTORS OR COPYRIGHT HOLDERS BE LIABLE FOR
 ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
 TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 SOFTWARE OR THE USE OR OTHER DEALINGS WITH THE SOFTWARE.

-->

<meta http-equiv="content-type" content="text/html; charset=UTF-8">
<title>Who's Affected</title>
<style>
	table, td, th
	{
		text-align:left;
		vertical-align:top;
		padding:5px;
		border:1px solid black;
		border-collapse:collapse;
	}
</style>

HTMLHEADER;

     echo $h;
     echo "</head>\n";
     echo "<body>\n";
     echo "<div>";
     echo "<H1>Who's Affected?</H1>";

}
